<link rel="import" href="/extern/bower_components/polymer/polymer.html">
<link rel="import" href="/extern/bower_components/paper-input/paper-input.html">
<link rel="import" href="/ts/common-elements/iron-flex-layout-attributes/iron-flex-layout-attributes.html">
<link rel="import" href="/ts/common-elements/reset-css/reset-css.html">
<link rel="import" href="/ts/common-elements/command-input/command-input.html">
<link rel="import" href="/extern/bower_components/juicy-jsoneditor/src/juicy-jsoneditor.html">
<link rel="import" href="/extern/bower_components/iron-a11y-keys/iron-a11y-keys.html">
<link rel="import" href="/ts/common-elements/ts-ajax/ts-ajax.html">
<link rel="import" href="/ts/common-elements/auto-update/auto-update.html">

<!--
`ts-command` is the element that renders a command panel.

Example:

    <ts-command name="My Command Panel" parameters="..."></ts-command>

Parameters should look something like this:

    [
      {
        "variable": "my_variable_name",
        "type": "string",
        "default": "my default value"
      },
      {
        "variable": "my_second_variable_name",
        "type": "int",
        "default": 42
      }
    ]

This element uses the [`command-input` element](/ts/common-elements/command-input/index.html)

-->
<dom-module id="ts-command">
    <template>
        <style include="iron-flex-layout-attributes"></style>
        <style include="reset-css"></style>
        <iron-a11y-keys target="[[_target]]"
                        keys="enter"
                        on-keys-pressed="_onEnter"></iron-a11y-keys>
        <style>
paper-material{padding:10px}form{margin-bottom:30px}[wrap] command-input{margin:10px;width:260px}pre[warning]{color:red}juicy-jsoneditor{margin-top:1em}#result>p{color:var(--paper-grey-600, gray)}#result{overflow:auto}

</style>
        <ts-ajax id="ajax" callback="ts-command-submit" handle-as="text" on-response="_handleResponse"></ts-ajax>
        <h2>{{name}}</h2>
        <div horizontal layout wrap>
            <template is="dom-repeat" items="{{parameters}}">
                <command-input id="[[_toId(item.variable)]]"
                               name="[[item.variable]]"
                               value="[[item.default]]"
                               type="[[item.type]]"></command-input>
            </template>
        </div>
        <paper-button raised on-click="_submit">Submit</paper-button>
        <h2>Result</h2>
        <auto-update id="autoupdate" callback="command-refresh" on-data-changed="_handleAutoupdate" no-refresh handle-as="text"></auto-update>
        <div id="result">
          <p>Awaiting the click of the 'submit' button...</p>
        </div>
    </template>
    <script>
Polymer({is:"ts-command",properties:{name:{type:String,value:""},parameters:{type:Array,value:function(){return[]}},_target:{type:Object,value:function(){return this}}},_onEnter:function(){this._submit()},_getLabel:function(name,variabletype){return name+" ("+variabletype+")"},_getValidationPattern:function(variabletype){switch(variabletype){case"bool":return"^(0|1|true|false|True|False)$";case"int":return"[0-9]*";case"unsigned int":return"[0-9]*";case"long":return"[0-9]*";case"unsigned long":return"[0-9]*";case"double":return"^[-+]?[0-9]*.?[0-9]+([eE][-+]?[0-9]+)?$";case"string":return".*";default:console.warn("<ts-command>: variable type '"+variabletype+"' is unknown, consider developing a validation pattern for it")}},_submit:function(event,detail,sender){var ajax=this.$.ajax;for(i=0;i<this.parameters.length;i++){var paramName=this.parameters[i].variable;ajax.push("parameters",paramName),ajax[paramName]=this.$$("[id='"+this._toId(this.parameters[i].variable+"']")).value}ajax.push("parameters","_eventType_"),ajax._eventType_="OnSubmit",this.$.ajax.generateRequest()},_isJSON:function(data){var json=!1;try{json=JSON.parse(this._unescapeHTML(data.replace("<pre>","").replace("</pre>","")))}catch(e){return!1}return json},_handleResponse:function(e){this._setResult(e.detail.response),this.$.autoupdate.set("noRefresh",!1)},_handleAutoupdate:function(e){var data=this.$.autoupdate.data;data&&""!=data&&this._setResult(data)},_setResult:function(data){var resultbox=Polymer.dom(this.$.result),json=this._isJSON(data);if(json){var curreneditor=resultbox.querySelector("juicy-jsoneditor");if(!curreneditor||JSON.stringify(json)!=JSON.stringify(curreneditor.get())){resultbox.innerHTML="";var juicyjson=document.createElement("juicy-jsoneditor");juicyjson.set("json",json),resultbox.appendChild(juicyjson),juicyjson.editor&&juicyjson.editor.expandAll()}}else resultbox.innerHTML=data},_toId:function(name){return name.replace(" ","_")},_unescapeHTML:function(escapedHTML){var div=document.createElement("div");return div.innerHTML=escapedHTML,0===div.childNodes.length?"":div.childNodes[0].nodeValue}});
</script>
</dom-module>
